﻿using System;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.IO;
using System.Linq;
using System.Net;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Xml;

public partial class WebPayQuery : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        String SessionedAmTopay, GetRequestResult;
        string Sessionedtxn_ref, SessionedProduct_id;
        String UnHash, Hash;
        string MAC = "D3D1D05AFE42AD50818167EAC73C109168A0F108F32645C8B59E897FA930DA44F9230910DAC9E20641823799A107A02068F7BC0F4CC41D2952E249552255710F";
        SessionedAmTopay = Convert.ToString(Session["QTkoboValue"]);
        Sessionedtxn_ref = Convert.ToString(Session["TransID"]);
        SessionedProduct_id = Convert.ToString(Session["productID"]);
        UnHash = SessionedProduct_id + Sessionedtxn_ref + MAC;

        Hash = Utility.hashSHA512(UnHash);

        string Requsesturi = string.Format("http://stageserv.interswitchng.com/test_paydirect/api/v1/gettransaction.xml?productid={0}&transactionreference={1}&amount={2}",
                                            Uri.EscapeDataString(SessionedProduct_id), Uri.EscapeDataString(Sessionedtxn_ref),
                                                Uri.EscapeDataString(SessionedAmTopay));

        HttpWebRequest webRequestObject = null;
        StreamReader sr = null;
        HttpWebResponse webResponseObject = null;


        try
        {
            string ResponseCode = "";
            string ResponseDescription = "";
            string Amount = "";
            string PaymentReference = "";
            string PaymentReferenceNo = "";
            string RetrievalReference = "";
            string TransactionDate = "";


            webRequestObject = (HttpWebRequest)WebRequest.Create(Requsesturi);

            webRequestObject.Headers.Add("Hash", Hash);
            webRequestObject.Method = "GET";

            webResponseObject = (HttpWebResponse)webRequestObject.GetResponse();
            sr = new StreamReader(webResponseObject.GetResponseStream());

            String Results = sr.ReadToEnd();


            XmlTextReader reader = new XmlTextReader(new System.IO.StringReader(Results));
            while (reader.Read())
            {
                // Only detect start elements.
                if (reader.IsStartElement())
                {

                    // Get element name and switch on it.
                    switch (reader.Name)
                    {
                        case "ResponseCode":
                            // Detect this element.
                            ResponseCode = reader.ReadInnerXml();
                            break;
                        case "ResponseDescription":
                            // Detect this element.
                            ResponseDescription = reader.ReadInnerXml();
                            break;
                        case "Amount":
                            // Detect this element.

                            Amount = reader.ReadInnerXml();
                            if (Amount == null || Amount == "")
                                Amount = "0.00";
                            break;
                        case "PaymentReference":
                            // Detect this element.
                            PaymentReference = reader.ReadInnerXml();
                            break;
                        case "PaymentReferenceNo":
                            // Detect this article element.
                            PaymentReferenceNo = reader.ReadInnerXml();
                            break;
                        case "RetrievalReference":
                            // Detect this article element.
                            RetrievalReference = reader.ReadInnerXml();
                            break;
                        case "TransactionDate":
                            // Detect this article element.
                            TransactionDate = reader.ReadInnerXml();
                            break;
                    }
                }
            }

            //XmlDocument xmlDoc = new XmlDocument();
            //xmlDoc.LoadXml(Results);

            //XmlNodeList xnList = xmlDoc.SelectNodes("/TransactionQueryResponse");
            //foreach (XmlNode xn in xnList)
            //{
            //     ResponseCode = xn["ResponseCode"].InnerText;
            //     ResponseDescription = xn["ResponseDescription"].InnerText;
            //     Amount = xn["Amount"].InnerText;
            //     //PaymentReference = xn["PaymentReference"].InnerText;
            //     // PaymentReferenceNo = xn["RetrievalReferenceNumber"].InnerText;
            //     //RetrievalReference = xn["RetrievalReference"].InnerText;
            //     TransactionDate = xn["TransactionDate"].InnerText;

            //insert the Transactions to the database

            //}

            //Display the Transaction on the web
            lbl_ResponseCode.Text = ResponseCode;

            lbl_TransResponse.Text = ResponseDescription;
            lbl_PaymentReferenceNo.Text = PaymentReference;
            Double NairaEQT = Convert.ToDouble(Amount) / 100;
            lbl_Amount.Text = "N" + NairaEQT.ToString();
            lbl_PaymentDate.Text = TransactionDate;


        }
        finally
        {
            try
            {
                sr.Close();
                webResponseObject.Close();
                webRequestObject.Abort();
            }
            catch { }
        }
    }
    protected void btnReturn_Click(object sender, EventArgs e)
    {
        Response.Redirect("Default.aspx");
    }
}